<?php

/**
 * Plugin Name: CasinoWare
 * Plugin URI: https://casinoware.com
 * Description: Live tournament, cash game and leaderboard information
 * Version: 0.9.14
 * Requires PHP: 7.4
 * Requires at least: 6.0
 * Author: Jens Harttmann
 * Author URI: https://casinoware.com
 * Text Domain: casinoware
 * Domain Path: /languages
 * License: GPL2
 * License URI: http://www.gnu.org/licenses/gpl-2.0.txt
 * Update URI: https://casinoware.com/downloads/wp/casinoware.zip
 * 
 * Copyright (c) 2023 Jens Harttmann / FLD GmbH
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License, version 2 or, at
 * your discretion, any later version, as published by the Free
 * Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

defined('ABSPATH') or die('No direct access');
define('CWPATH', plugin_dir_path(__FILE__));
define('CWURL', plugin_dir_url(__FILE__));
define('CWNAME', plugin_basename(__FILE__)); // casinoware/casinoware
define('CWSLUG', plugin_basename(__DIR__)); // casinoware

if (file_exists(CWPATH . '/includes/autoloader.inc.php')) {
	require(CWPATH . '/includes/autoloader.inc.php');
}

/**
 * Get the team list instance.
 *
 * @return CasinoWare Plugin instance.
 */
function cwPlugIn()
{
	static $casinoware = null;
	return $casinoware === null ? ($casinoware = new CWPlugIn()) : $casinoware;
}

register_activation_hook(__FILE__, [CWPlugIn::class, 'activate']);
register_deactivation_hook(__FILE__, [CWPlugIn::class, 'deactivate']);
add_action('plugins_loaded', [cwPlugIn(), 'register']);
