<?php
defined('ABSPATH') or die('No direct access');
class CWPlayer extends CWBase
{
	protected $dname;
	protected $email;
	protected $ensign;

	public function __construct($data)
	{
		parent::__construct('player', 'PLID', $data);
	}

	/* ---------------------------------------------- */
	/* Override
	/* ---------------------------------------------- */
	public function loadData($attr)
	{
		global $wpdb;
		$data = $wpdb->get_row("SELECT * FROM `{$wpdb->prefix}cw_players` WHERE `ID` = {$attr}", ARRAY_A);
		return $data;
	}

	public function setData($data)
	{
		switch (gettype($data)) {
			case 'string':
				$data = json_decode($data, true, 6);
				break;
			case 'integer':
				$data =  $this->loadData((int)$data);
				break;
		}
		if ('array' !== gettype($data))
			return;
		if ($ID = $this->valueForKey($data, 'ID')) {
			$this->ID = $ID;
		}
		$this->LCID = $this->valueForKey($data, 'LCID');
		$this->modified_utc = $this->valueForKey($data, 'modified_utc');
		$vars = [
			$this->idfield, 'address', 'ensign', 'dname', 'email',
			'stat0count', 'stat0value', 'stat1count', 'stat1value', 'stat2count', 'stat2value', 'stat3count', 'stat3value', 'stat4count', 'stat4value',
			'earn0count', 'earn0value', 'earn1count', 'earn1value', 'earn2count', 'earn2value', 'earn3count', 'earn3value', 'earn4count', 'earn4value'
		];
		foreach ($vars as $prop) {
			if (isset($data[$prop])) {
				$this->$prop = $data[$prop];
			} else {
				$this->$prop = null;
			}
		}
	}
	/* ---------------------------------------------- */
	/* Memebers
	/* ---------------------------------------------- */

	/* ---------------------------------------------- */
	/* Render
	/* ---------------------------------------------- */
	public function formattedValue($key, $args = null)
	{
		switch ($key) {
			case 'id':
				$v = $this->id();
				break;
			case 'plid':
				$field = $this->idfield;
				$v = $this->$field;
				break;
			case 'lcid':
				$v = $this->lcid();
				break;
			case 'dname':
				$v = $this->dname ? esc_html($this->dname) : null;
				break;
			case 'email':
				$v = $this->email ? esc_html($this->email) : null;
				break;
			case 'ensign':
				if (!empty($ensign = $this->ensign)) {
					$path = "imgs/icons/{$ensign}-icon.gif";
					if (file_exists(CWPATH . $path)) {
						$src = CWURL . $path;
						$v = "<img style=\"margin: auto 0 auto 0;\" src=\"{$src}\" title=\"{$ensign}\" alt=\"{$ensign}\">";
					} else {
						$v = esc_html($ensign);
					}
				} else {
					$v = "-";
				}
				break;
			case 'ensign.dname':
				$name = esc_html($this->dname);
				$ensign = $this->ensign;
				$path = "imgs/icons/{$ensign}-icon.gif";
				if (file_exists(CWPATH . $path)) {
					$src = CWURL . $path;
					$img = "<img style=\"margin: auto 0 auto 0;vertical-align:middle;\" src=\"{$src}\" title=\"{$ensign}\" alt=\"{$ensign}\">";
				} else {
					$img = esc_html($ensign);
				}
				$v = $img . '&nbsp;&nbsp;' . $name;
				break;
			default:
				if (5 == strlen($key)) {
					$cat = substr($key, 0, 4);
					$currency = (int)substr($key, -1);
					$propv = $cat . $currency . "value";
					$propc = $cat . $currency . "count";
					if (property_exists($this, $propv) && property_exists($this, $propc)) {
						$v = (float)$this->$propv;
						$decimals = ceil($v) === $v ? 0 : 2;
						$v = number_format_i18n($this->$propv, $decimals);
						// $v = $this->formatValueWithCurrency($v, $currency);
						$c = $this->$propc;
						$v = $c . " | " . $v;
					} else {
						$v = null;
					}
				} else {
					$v = null;
				}
		}
		return $v;
	}
}
