<?php
defined('ABSPATH') or die('No direct access');

require_once ABSPATH . 'wp-admin/install-helper.php';

class CWPlugInManager
{
	public $errorMsgs = [];

	public function checkOptions()
	{
		$errors = 0;

		if (!get_option('cw_options_general')) {
			$defaults = ['tournaments_manager' => 1, 'cashgames_manager' => 0, 'leaderboard_manager' => 0, 'currency_0' => "€", 'currency_pos_0' => 2];
			update_option('cw_options_general', $defaults);
		}
		if (!get_option('cw_options_tournament_schedule')) {
			$serialized = 'a:33:{s:7:"wrapper";i:1;s:4:"card";i:1;s:10:"card_title";s:8:"Schedule";s:11:"card_footer";s:32:"Tournament Director\'s Discretion";s:13:"table_headers";i:1;s:7:"grouped";i:1;s:6:"drawer";s:2:"md";s:15:"details_page_id";i:0;s:5:"limit";i:0;s:10:"empty_list";s:24:"No tournament scheduled!";s:5:"color";a:1:{s:7:"enabled";i:1;}s:16:"start_date_local";a:6:{s:7:"enabled";i:0;s:6:"detail";i:0;s:5:"title";s:0:"";s:5:"width";i:0;s:5:"align";s:6:"center";s:8:"collapse";s:0:"";}s:16:"start_time_local";a:6:{s:7:"enabled";i:1;s:6:"detail";i:0;s:5:"title";s:5:"Start";s:5:"width";i:80;s:5:"align";s:6:"center";s:8:"collapse";s:0:"";}s:21:"start_date_time_local";a:6:{s:7:"enabled";i:0;s:6:"detail";i:0;s:5:"title";s:5:"Start";s:5:"width";i:0;s:5:"align";s:6:"center";s:8:"collapse";s:0:"";}s:5:"title";a:6:{s:7:"enabled";i:1;s:6:"detail";i:0;s:5:"title";s:4:"Name";s:5:"width";i:0;s:5:"align";s:5:"start";s:8:"collapse";s:0:"";}s:14:"shortlimitgame";a:6:{s:7:"enabled";i:0;s:6:"detail";i:1;s:5:"title";s:4:"Game";s:5:"width";i:0;s:5:"align";s:6:"center";s:8:"collapse";s:0:"";}s:8:"costspb0";a:6:{s:7:"enabled";i:1;s:6:"detail";i:1;s:5:"title";s:6:"Buy-In";s:5:"width";i:140;s:5:"align";s:6:"center";s:8:"collapse";s:2:"sm";}s:11:"guaranteed0";a:6:{s:7:"enabled";i:1;s:6:"detail";i:1;s:5:"title";s:3:"GTD";s:5:"width";i:80;s:5:"align";s:6:"center";s:8:"collapse";s:2:"lg";}s:10:"prizepool0";a:6:{s:7:"enabled";i:0;s:6:"detail";i:0;s:5:"title";s:10:"Prize Pool";s:5:"width";i:120;s:5:"align";s:6:"center";s:8:"collapse";s:2:"lg";}s:4:"pcol";a:6:{s:7:"enabled";i:1;s:6:"detail";i:1;s:5:"title";s:6:"Trophy";s:5:"width";i:60;s:5:"align";s:6:"center";s:8:"collapse";s:3:"xxl";}s:14:"level_duration";a:6:{s:7:"enabled";i:1;s:6:"detail";i:0;s:5:"title";s:5:"Clock";s:5:"width";i:90;s:5:"align";s:6:"center";s:8:"collapse";s:2:"xl";}s:17:"additional_buyins";a:6:{s:7:"enabled";i:1;s:6:"detail";i:1;s:5:"title";s:4:"Type";s:5:"width";i:100;s:5:"align";s:6:"center";s:8:"collapse";s:2:"md";}s:10:"startchips";a:6:{s:7:"enabled";i:1;s:6:"detail";i:1;s:5:"title";s:5:"Chips";s:5:"width";i:80;s:5:"align";s:6:"center";s:8:"collapse";s:2:"xl";}s:8:"totalens";a:6:{s:7:"enabled";i:0;s:6:"detail";i:1;s:5:"title";s:7:"Entries";s:5:"width";i:0;s:5:"align";s:6:"center";s:8:"collapse";s:3:"xxl";}s:8:"countpls";a:6:{s:7:"enabled";i:0;s:6:"detail";i:1;s:5:"title";s:7:"Players";s:5:"width";i:0;s:5:"align";s:6:"center";s:8:"collapse";s:3:"xxl";}s:8:"countwas";a:6:{s:7:"enabled";i:0;s:6:"detail";i:0;s:5:"title";s:0:"";s:5:"width";i:0;s:5:"align";s:6:"center";s:8:"collapse";s:3:"xxl";}s:6:"xlevel";a:6:{s:7:"enabled";i:1;s:6:"detail";i:1;s:5:"title";s:8:"Reg Ends";s:5:"width";i:80;s:5:"align";s:6:"center";s:8:"collapse";s:3:"xxl";}s:3:"reg";a:6:{s:7:"enabled";i:0;s:6:"detail";i:1;s:5:"title";s:6:"Status";s:5:"width";i:100;s:5:"align";s:6:"center";s:8:"collapse";s:3:"xxl";}s:6:"status";a:6:{s:7:"enabled";i:0;s:6:"detail";i:0;s:5:"title";s:6:"Status";s:5:"width";i:0;s:5:"align";s:6:"center";s:8:"collapse";s:3:"xxl";}s:9:"shortdesc";a:1:{s:6:"detail";i:1;}s:6:"levels";a:1:{s:6:"detail";i:0;}s:4:"more";a:6:{s:7:"enabled";i:0;s:6:"detail";i:0;s:5:"title";s:7:"Details";s:5:"width";i:0;s:5:"align";s:6:"center";s:8:"collapse";s:0:"";}s:8:"pulldown";a:3:{s:7:"enabled";i:1;s:9:"accordion";i:1;s:5:"width";i:54;}}';
			$defaults = unserialize($serialized);
			update_option('cw_options_tournament_schedule', $defaults);
		}
		if (!get_option('cw_options_tournament_list')) {
			$serialized = 'a:35:{s:7:"wrapper";i:1;s:4:"card";i:1;s:10:"card_title";s:11:"Tournaments";s:11:"card_footer";s:32:"Tournament Director\'s Discretion";s:13:"table_headers";i:1;s:7:"grouped";i:1;s:6:"drawer";s:2:"md";s:15:"details_page_id";i:0;s:5:"limit";i:50;s:10:"empty_list";s:14:"List is empty!";s:5:"color";a:1:{s:7:"enabled";i:1;}s:16:"start_date_local";a:6:{s:7:"enabled";i:0;s:6:"detail";i:0;s:5:"title";s:0:"";s:5:"width";i:0;s:5:"align";s:6:"center";s:8:"collapse";s:0:"";}s:16:"start_time_local";a:6:{s:7:"enabled";i:1;s:6:"detail";i:0;s:5:"title";s:5:"Start";s:5:"width";i:80;s:5:"align";s:6:"center";s:8:"collapse";s:0:"";}s:21:"start_date_time_local";a:6:{s:7:"enabled";i:0;s:6:"detail";i:0;s:5:"title";s:5:"Start";s:5:"width";i:0;s:5:"align";s:6:"center";s:8:"collapse";s:0:"";}s:5:"title";a:6:{s:7:"enabled";i:1;s:6:"detail";i:0;s:5:"title";s:4:"Name";s:5:"width";i:0;s:5:"align";s:5:"start";s:8:"collapse";s:0:"";}s:14:"shortlimitgame";a:6:{s:7:"enabled";i:0;s:6:"detail";i:1;s:5:"title";s:4:"Game";s:5:"width";i:0;s:5:"align";s:6:"center";s:8:"collapse";s:0:"";}s:8:"costspb0";a:6:{s:7:"enabled";i:1;s:6:"detail";i:1;s:5:"title";s:6:"Buy-In";s:5:"width";i:140;s:5:"align";s:6:"center";s:8:"collapse";s:2:"sm";}s:11:"guaranteed0";a:6:{s:7:"enabled";i:0;s:6:"detail";i:0;s:5:"title";s:3:"GTD";s:5:"width";i:80;s:5:"align";s:6:"center";s:8:"collapse";s:2:"md";}s:10:"prizepool0";a:6:{s:7:"enabled";i:1;s:6:"detail";i:1;s:5:"title";s:10:"Prize Pool";s:5:"width";i:100;s:5:"align";s:6:"center";s:8:"collapse";s:2:"md";}s:4:"pcol";a:6:{s:7:"enabled";i:0;s:6:"detail";i:0;s:5:"title";s:0:"";s:5:"width";i:0;s:5:"align";s:6:"center";s:8:"collapse";s:0:"";}s:14:"level_duration";a:6:{s:7:"enabled";i:1;s:6:"detail";i:0;s:5:"title";s:5:"Clock";s:5:"width";i:90;s:5:"align";s:6:"center";s:8:"collapse";s:3:"xxl";}s:17:"additional_buyins";a:6:{s:7:"enabled";i:0;s:6:"detail";i:1;s:5:"title";s:4:"Type";s:5:"width";i:0;s:5:"align";s:6:"center";s:8:"collapse";s:0:"";}s:10:"startchips";a:6:{s:7:"enabled";i:1;s:6:"detail";i:1;s:5:"title";s:5:"Chips";s:5:"width";i:80;s:5:"align";s:6:"center";s:8:"collapse";s:2:"xl";}s:8:"totalens";a:6:{s:7:"enabled";i:1;s:6:"detail";i:1;s:5:"title";s:7:"Entries";s:5:"width";i:60;s:5:"align";s:6:"center";s:8:"collapse";s:2:"lg";}s:8:"countpls";a:6:{s:7:"enabled";i:0;s:6:"detail";i:1;s:5:"title";s:7:"Players";s:5:"width";i:60;s:5:"align";s:6:"center";s:8:"collapse";s:2:"lg";}s:8:"countwas";a:6:{s:7:"enabled";i:0;s:6:"detail";i:0;s:5:"title";s:0:"";s:5:"width";i:0;s:5:"align";s:6:"center";s:8:"collapse";s:0:"";}s:11:"counttables";a:6:{s:7:"enabled";i:0;s:6:"detail";i:0;s:5:"title";s:0:"";s:5:"width";i:0;s:5:"align";s:6:"center";s:8:"collapse";s:0:"";}s:9:"freeseats";a:6:{s:7:"enabled";i:0;s:6:"detail";i:0;s:5:"title";s:0:"";s:5:"width";i:0;s:5:"align";s:6:"center";s:8:"collapse";s:0:"";}s:6:"xlevel";a:6:{s:7:"enabled";i:0;s:6:"detail";i:1;s:5:"title";s:8:"Reg Ends";s:5:"width";i:80;s:5:"align";s:6:"center";s:8:"collapse";s:2:"xl";}s:3:"reg";a:6:{s:7:"enabled";i:1;s:6:"detail";i:1;s:5:"title";s:6:"Status";s:5:"width";i:140;s:5:"align";s:6:"center";s:8:"collapse";s:2:"lg";}s:6:"status";a:6:{s:7:"enabled";i:0;s:6:"detail";i:0;s:5:"title";s:6:"Status";s:5:"width";i:0;s:5:"align";s:6:"center";s:8:"collapse";s:0:"";}s:9:"shortdesc";a:1:{s:6:"detail";i:1;}s:6:"levels";a:1:{s:6:"detail";i:0;}s:4:"more";a:6:{s:7:"enabled";i:0;s:6:"detail";i:1;s:5:"title";s:24:"Show me some details ...";s:5:"width";i:0;s:5:"align";s:6:"center";s:8:"collapse";s:0:"";}s:8:"pulldown";a:3:{s:7:"enabled";i:1;s:9:"accordion";i:1;s:5:"width";i:54;}}';
			$defaults = unserialize($serialized);
			update_option('cw_options_tournament_list', $defaults);
		}
		if (!get_option('cw_options_tournament_results')) {
			$serialized = 'a:33:{s:7:"wrapper";i:1;s:4:"card";i:1;s:10:"card_title";s:7:"Results";s:11:"card_footer";s:24:"All the results you need";s:13:"table_headers";i:1;s:7:"grouped";i:1;s:6:"drawer";s:2:"md";s:15:"details_page_id";i:0;s:5:"limit";i:50;s:10:"empty_list";s:21:"No results available!";s:5:"color";a:1:{s:7:"enabled";i:1;}s:16:"start_date_local";a:6:{s:7:"enabled";i:0;s:6:"detail";i:0;s:5:"title";s:0:"";s:5:"width";i:0;s:5:"align";s:6:"center";s:8:"collapse";s:0:"";}s:16:"start_time_local";a:6:{s:7:"enabled";i:0;s:6:"detail";i:0;s:5:"title";s:5:"Start";s:5:"width";i:80;s:5:"align";s:6:"center";s:8:"collapse";s:0:"";}s:21:"start_date_time_local";a:6:{s:7:"enabled";i:0;s:6:"detail";i:0;s:5:"title";s:5:"Start";s:5:"width";i:0;s:5:"align";s:6:"center";s:8:"collapse";s:0:"";}s:5:"title";a:6:{s:7:"enabled";i:1;s:6:"detail";i:0;s:5:"title";s:4:"Name";s:5:"width";i:0;s:5:"align";s:5:"start";s:8:"collapse";s:0:"";}s:14:"shortlimitgame";a:6:{s:7:"enabled";i:0;s:6:"detail";i:1;s:5:"title";s:4:"Game";s:5:"width";i:0;s:5:"align";s:6:"center";s:8:"collapse";s:0:"";}s:8:"costspb0";a:6:{s:7:"enabled";i:1;s:6:"detail";i:1;s:5:"title";s:6:"Buy-In";s:5:"width";i:140;s:5:"align";s:6:"center";s:8:"collapse";s:2:"sm";}s:11:"guaranteed0";a:6:{s:7:"enabled";i:0;s:6:"detail";i:1;s:5:"title";s:3:"GTD";s:5:"width";i:80;s:5:"align";s:6:"center";s:8:"collapse";s:2:"lg";}s:10:"prizepool0";a:6:{s:7:"enabled";i:1;s:6:"detail";i:1;s:5:"title";s:10:"Prize Pool";s:5:"width";i:120;s:5:"align";s:6:"center";s:8:"collapse";s:2:"lg";}s:4:"pcol";a:6:{s:7:"enabled";i:0;s:6:"detail";i:1;s:5:"title";s:6:"Trophy";s:5:"width";i:60;s:5:"align";s:6:"center";s:8:"collapse";s:3:"xxl";}s:14:"level_duration";a:6:{s:7:"enabled";i:0;s:6:"detail";i:0;s:5:"title";s:5:"Clock";s:5:"width";i:90;s:5:"align";s:6:"center";s:8:"collapse";s:2:"xl";}s:17:"additional_buyins";a:6:{s:7:"enabled";i:0;s:6:"detail";i:1;s:5:"title";s:4:"Type";s:5:"width";i:100;s:5:"align";s:6:"center";s:8:"collapse";s:2:"md";}s:10:"startchips";a:6:{s:7:"enabled";i:0;s:6:"detail";i:1;s:5:"title";s:5:"Chips";s:5:"width";i:80;s:5:"align";s:6:"center";s:8:"collapse";s:2:"xl";}s:8:"totalens";a:6:{s:7:"enabled";i:1;s:6:"detail";i:1;s:5:"title";s:7:"Entries";s:5:"width";i:80;s:5:"align";s:6:"center";s:8:"collapse";s:2:"md";}s:8:"countpls";a:6:{s:7:"enabled";i:0;s:6:"detail";i:0;s:5:"title";s:7:"Players";s:5:"width";i:0;s:5:"align";s:6:"center";s:8:"collapse";s:3:"xxl";}s:8:"countwas";a:6:{s:7:"enabled";i:0;s:6:"detail";i:0;s:5:"title";s:0:"";s:5:"width";i:0;s:5:"align";s:6:"center";s:8:"collapse";s:3:"xxl";}s:6:"xlevel";a:6:{s:7:"enabled";i:0;s:6:"detail";i:0;s:5:"title";s:8:"Reg Ends";s:5:"width";i:80;s:5:"align";s:6:"center";s:8:"collapse";s:3:"xxl";}s:3:"reg";a:6:{s:7:"enabled";i:0;s:6:"detail";i:0;s:5:"title";s:6:"Status";s:5:"width";i:100;s:5:"align";s:6:"center";s:8:"collapse";s:3:"xxl";}s:6:"status";a:6:{s:7:"enabled";i:0;s:6:"detail";i:1;s:5:"title";s:6:"Status";s:5:"width";i:0;s:5:"align";s:6:"center";s:8:"collapse";s:3:"xxl";}s:9:"shortdesc";a:1:{s:6:"detail";i:1;}s:6:"levels";a:1:{s:6:"detail";i:0;}s:4:"more";a:6:{s:7:"enabled";i:1;s:6:"detail";i:1;s:5:"title";s:4:"List";s:5:"width";i:80;s:5:"align";s:6:"center";s:8:"collapse";s:2:"md";}s:8:"pulldown";a:3:{s:7:"enabled";i:1;s:9:"accordion";i:1;s:5:"width";i:54;}}';
			$defaults = unserialize($serialized);
			update_option('cw_options_tournament_results', $defaults);
		}
		if (!get_option('cw_options_tournament_details')) {
			$defaults = ['wrapper' => 1, 'card' => 1, 'entries' => 1, 'tables' => 1, 'waits' => 0];
			update_option('cw_options_tournament_details', $defaults);
		}
		if (!get_option('cw_options_cashgame_list')) {
			$serialized = 'a:25:{s:7:"wrapper";i:1;s:4:"card";i:1;s:10:"card_title";s:18:"Running Cash Games";s:11:"card_footer";s:20:"Make your choice now";s:13:"table_headers";i:1;s:7:"grouped";i:1;s:6:"drawer";s:2:"md";s:15:"details_page_id";i:0;s:5:"limit";i:0;s:10:"empty_list";s:14:"List is empty!";s:5:"color";a:1:{s:7:"enabled";i:1;}s:5:"title";a:6:{s:7:"enabled";i:1;s:6:"detail";i:0;s:5:"title";s:4:"Name";s:5:"width";i:0;s:5:"align";s:5:"start";s:8:"collapse";s:0:"";}s:14:"shortlimitgame";a:6:{s:7:"enabled";i:0;s:6:"detail";i:1;s:5:"title";s:4:"Game";s:5:"width";i:0;s:5:"align";s:6:"center";s:8:"collapse";s:0:"";}s:6:"minmax";a:6:{s:7:"enabled";i:1;s:6:"detail";i:1;s:5:"title";s:6:"Buy-In";s:5:"width";i:160;s:5:"align";s:6:"center";s:8:"collapse";s:2:"sm";}s:4:"pcol";a:6:{s:7:"enabled";i:1;s:6:"detail";i:0;s:5:"title";s:7:"Special";s:5:"width";i:80;s:5:"align";s:6:"center";s:8:"collapse";s:2:"lg";}s:8:"totalens";a:6:{s:7:"enabled";i:0;s:6:"detail";i:0;s:5:"title";s:0:"";s:5:"width";i:0;s:5:"align";s:6:"center";s:8:"collapse";s:0:"";}s:8:"countpls";a:6:{s:7:"enabled";i:1;s:6:"detail";i:1;s:5:"title";s:7:"Players";s:5:"width";i:60;s:5:"align";s:6:"center";s:8:"collapse";s:2:"md";}s:8:"countwas";a:6:{s:7:"enabled";i:1;s:6:"detail";i:0;s:5:"title";s:7:"Waiting";s:5:"width";i:60;s:5:"align";s:6:"center";s:8:"collapse";s:2:"md";}s:11:"counttables";a:6:{s:7:"enabled";i:0;s:6:"detail";i:1;s:5:"title";s:6:"Tables";s:5:"width";i:0;s:5:"align";s:6:"center";s:8:"collapse";s:0:"";}s:9:"freeseats";a:6:{s:7:"enabled";i:0;s:6:"detail";i:0;s:5:"title";s:0:"";s:5:"width";i:0;s:5:"align";s:6:"center";s:8:"collapse";s:0:"";}s:3:"reg";a:6:{s:7:"enabled";i:1;s:6:"detail";i:0;s:5:"title";s:6:"Status";s:5:"width";i:100;s:5:"align";s:6:"center";s:8:"collapse";s:0:"";}s:6:"status";a:6:{s:7:"enabled";i:0;s:6:"detail";i:0;s:5:"title";s:6:"Status";s:5:"width";i:100;s:5:"align";s:6:"center";s:8:"collapse";s:0:"";}s:9:"shortdesc";a:1:{s:6:"detail";i:1;}s:4:"more";a:6:{s:7:"enabled";i:0;s:6:"detail";i:1;s:5:"title";s:7:"Details";s:5:"width";i:0;s:5:"align";s:6:"center";s:8:"collapse";s:0:"";}s:8:"pulldown";a:3:{s:7:"enabled";i:1;s:9:"accordion";i:1;s:5:"width";i:54;}}';
			$defaults = unserialize($serialized);
			update_option('cw_options_cashgame_list', $defaults);
		}
		if (!get_option('cw_options_cashgame_details')) {
			$defaults = ['wrapper' => 1, 'card' => 1, 'entries' => 0, 'tables' => 1, 'waits' => 1];
			update_option('cw_options_cashgame_details', $defaults);
		}
		if (!get_option('cw_options_leaderboard')) {
			$serialized = 'a:17:{s:7:"wrapper";i:1;s:4:"card";i:1;s:10:"card_title";s:11:"Leaderboard";s:11:"card_footer";s:20:"Who is the champion?";s:13:"table_headers";i:1;s:6:"drawer";s:0:"";s:10:"empty_list";s:14:"List is empty!";s:10:"search_bar";i:1;s:18:"search_placeholder";s:16:"Search player...";s:4:"rank";a:6:{s:7:"enabled";i:1;s:6:"detail";i:0;s:5:"title";s:4:"Rank";s:5:"width";i:60;s:5:"align";s:6:"center";s:8:"collapse";s:0:"";}s:6:"ensign";a:6:{s:7:"enabled";i:1;s:6:"detail";i:0;s:5:"title";s:0:"";s:5:"width";i:30;s:5:"align";s:6:"center";s:8:"collapse";s:2:"sm";}s:6:"member";a:6:{s:7:"enabled";i:0;s:6:"detail";i:0;s:5:"title";s:0:"";s:5:"width";i:0;s:5:"align";s:6:"center";s:8:"collapse";s:0:"";}s:5:"dname";a:6:{s:7:"enabled";i:1;s:6:"detail";i:0;s:5:"title";s:0:"";s:5:"width";i:0;s:5:"align";s:5:"start";s:8:"collapse";s:0:"";}s:4:"mdno";a:6:{s:7:"enabled";i:0;s:6:"detail";i:0;s:5:"title";s:0:"";s:5:"width";i:0;s:5:"align";s:6:"center";s:8:"collapse";s:0:"";}s:5:"ptime";a:6:{s:7:"enabled";i:0;s:6:"detail";i:0;s:5:"title";s:0:"";s:5:"width";i:0;s:5:"align";s:6:"center";s:8:"collapse";s:0:"";}s:8:"curcount";a:6:{s:7:"enabled";i:1;s:6:"detail";i:0;s:5:"title";s:1:"#";s:5:"width";i:40;s:5:"align";s:6:"center";s:8:"collapse";s:2:"sm";}s:8:"curvalue";a:6:{s:7:"enabled";i:1;s:6:"detail";i:0;s:5:"title";s:6:"Points";s:5:"width";i:80;s:5:"align";s:3:"end";s:8:"collapse";s:0:"";}}';
			$defaults = unserialize($serialized);
			update_option('cw_options_leaderboard', $defaults);
		}
		if (!get_option('cw_options_api')) {
			$defaults = ['sender_apikey' => md5(time())];
			update_option('cw_options_api', $defaults);
		}

		return $errors;
	}

	public function checkTables()
	{
		global $wpdb;
		$errors = 0;

		$tablename = $wpdb->prefix . 'cw_tournaments';
		if (!$this->hasTableWithName($tablename)) {
			$errors += $this->createTournamentsTable($tablename);
		} else {
			$errors += $this->updateBaseGamesTable($tablename);
		}

		$tablename = $wpdb->prefix . 'cw_cashgames';
		if (!$this->hasTableWithName($tablename)) {
			$errors += $this->createCashGamesTable($tablename);
		} else {
			$errors += $this->updateBaseGamesTable($tablename);
		}

		$tablename = $wpdb->prefix . 'cw_players';
		if (!$this->hasTableWithName($tablename)) {
			$errors += $this->createPlayersTable($tablename);
		} else {
			$errors += $this->updatePlayersTable($tablename);
		}

		return $errors;
	}

	protected function hasTableWithName($tablename)
	{
		global $wpdb;

		foreach ($wpdb->get_col('SHOW TABLES', 0) as $table) {
			if ($table === $tablename) {
				return true;
			}
		}
		return false;
	}

	protected function maybeCreateTableWithIndex($tablename, $indexname, $query)
	{
		global $wpdb;

		if (!empty($query)) {
			$q = "SELECT COUNT(1) AS count FROM INFORMATION_SCHEMA.STATISTICS WHERE `TABLE_SCHEMA`=DATABASE() AND `TABLE_NAME`='{$tablename}' AND index_name='{$indexname}';";
			$count = $wpdb->get_var($q);
			if (false === $count || null === $count) {
				return false;
			} else if (0 == $count) {
				if (!$wpdb->query($query)) {
					if ($msg = $wpdb->last_error) {
						$this->errorMsgs[] = $msg;
					}
					return false;
				}
			}
		}

		return true;
	}

	protected function updateBaseGamesTable($tablename)
	{
		global $wpdb;
		$errors = 0;

		// COLUMN general
		$q = "ALTER TABLE {$tablename} DROP COLUMN general;";
		if (!maybe_drop_column($tablename, 'general', $q)) {
			if ($msg = $wpdb->last_error) {
				$this->errorMsgs[] = $msg;
			}
			$errors++;
		}
		// COLUMN modified_utc
		$q = "ALTER TABLE {$tablename} ADD COLUMN `start_utc` datetime DEFAULT NULL COMMENT 'start gmt' AFTER league;";
		if (!maybe_add_column($tablename, 'start_utc', $q)) {
			if ($msg = $wpdb->last_error) {
				$this->errorMsgs[] = $msg;
			}
			$errors++;
		}
		// COLUMN modified_utc
		$q = "ALTER TABLE {$tablename} ADD COLUMN `modified_utc` datetime DEFAULT NULL COMMENT 'last update gmt' AFTER ID;";
		if (!maybe_add_column($tablename, 'modified_utc', $q)) {
			if ($msg = $wpdb->last_error) {
				$this->errorMsgs[] = $msg;
			}
			$errors++;
		}
		// COLUMN modified_local
		$q = "ALTER TABLE {$tablename} ADD COLUMN `modified_local` datetime DEFAULT NULL COMMENT 'last update local time' AFTER modified_utc;";
		if (!maybe_add_column($tablename, 'modified_local', $q)) {
			if ($msg = $wpdb->last_error) {
				$this->errorMsgs[] = $msg;
			}
			$errors++;
		}

		return $errors;
	}

	protected function updatePlayersTable($tablename)
	{
		$errors = 0;

		$indexes = ['email', 'dname'];
		foreach ($indexes as $indexname) {
			$q = "CREATE INDEX `{$indexname}` ON `{$tablename}` (`{$indexname}`);";
			if (!$this->maybeCreateTableWithIndex($tablename, $indexname, $q)) {
				$errors++;
			}
		}

		// INDEX Local Stat1 Count
		for ($index = 0; $index < 5; $index++) {
			$indexname = "Local Stat{$index} Count";
			$q = "CREATE INDEX `{$indexname}` ON `{$tablename}` (`LCID`,`stat{$index}count`);";
			if (!$this->maybeCreateTableWithIndex($tablename, $indexname, $q)) {
				$errors++;
			}
		}
		// INDEX Local Stat1 Count
		for ($index = 0; $index < 5; $index++) {
			$indexname = "Local Earn{$index} Count";
			$q = "CREATE INDEX `{$indexname}` ON `{$tablename}` (`LCID`,`earn{$index}count`);";
			if (!$this->maybeCreateTableWithIndex($tablename, $indexname, $q)) {
				$errors++;
			}
		}

		return $errors;
	}

	protected function createTournamentsTable($tablename)
	{
		global $wpdb;
		$errors = 0;

		$q = "CREATE TABLE `{$tablename}` (
         `ID` int(11) unsigned NOT NULL AUTO_INCREMENT,
         `modified_utc` datetime DEFAULT NULL COMMENT 'last update gmt',
         `modified_local` datetime DEFAULT NULL COMMENT 'last update local time',
         `LCID` int(11) unsigned NOT NULL COMMENT 'location ID',
         `TTID` int(11) unsigned NOT NULL COMMENT 'tournament ID',
         `EVID` int(11) unsigned DEFAULT NULL COMMENT 'event ID',
         `GGID` int(11) unsigned DEFAULT NULL COMMENT 'group ID',
         `status` tinyint(3) NOT NULL DEFAULT '0' COMMENT 'base status bits 0x1f',
         `pub` tinyint(3) NOT NULL DEFAULT '0' COMMENT 'published, 0 false, 1 true',
         `type` tinyint(3) DEFAULT '-1' COMMENT 'type, 0 sitgo, 1 ring, 2 dated',
         `league` varchar(64) DEFAULT NULL COMMENT 'name of the league',
         `start_utc` datetime NULL DEFAULT NULL COMMENT 'start gmt',
         `start_local` datetime NULL DEFAULT NULL COMMENT 'start local time',
         `title` varchar(100) DEFAULT NULL COMMENT 'name of the tournament',
         `params` mediumtext,
         `entries` mediumtext,
         `tables` mediumtext,
         `waits` mediumtext,
         `levels` mediumtext,
         `payouts` mediumtext,
         PRIMARY KEY (`ID`),
         UNIQUE KEY `Unique Host ID` (`LCID`,`TTID`),
         KEY `published` (`pub`),
         KEY `status` (`status`),
         KEY `LCID` (`LCID`),
         KEY `EVID` (`EVID`),
         KEY `GGID` (`GGID`),
         KEY `type` (`type`),
         KEY `league` (`league`)
         ) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;";

		if (!$wpdb->query($q)) {
			$errors++;
			if ($msg = $wpdb->last_error) {
				$this->errorMsgs[] = $msg;
			}
		}

		return $errors;
	}

	protected function createCashGamesTable($tablename)
	{
		global $wpdb;
		$errors = 0;

		$q = "CREATE TABLE `{$tablename}` (
         `ID` int(11) unsigned NOT NULL AUTO_INCREMENT,
         `modified_utc` datetime DEFAULT NULL COMMENT 'last update gmt',
         `modified_local` datetime DEFAULT NULL COMMENT 'last update local time',
         `LCID` int(11) unsigned NOT NULL COMMENT 'location ID',
         `CGID` int(11) unsigned NOT NULL COMMENT 'cash game ID',
         `EVID` int(11) unsigned DEFAULT NULL COMMENT 'event ID',
         `GGID` int(11) unsigned DEFAULT NULL COMMENT 'group ID',
         `status` tinyint(3) NOT NULL DEFAULT '0' COMMENT 'base status bits 0x1f',
         `pub` tinyint(3) NOT NULL DEFAULT '0' COMMENT 'published, 0 false, 1 true',
         `type` tinyint(3) DEFAULT '-1' COMMENT 'type, 0 sitgo, 1 ring, 2 dated',
         `league` varchar(64) DEFAULT NULL COMMENT 'name of the league',
         `start_utc` datetime NULL DEFAULT NULL COMMENT 'start gmt',
         `start_local` datetime NULL DEFAULT NULL COMMENT 'start local time',
         `title` varchar(100) DEFAULT NULL COMMENT 'name of the cash game',
         `params` mediumtext,
         `entries` mediumtext,
         `tables` mediumtext,
         `waits` mediumtext,
         PRIMARY KEY (`ID`),
         UNIQUE KEY `Unique Host ID` (`LCID`,`CGID`),
         KEY `published` (`pub`),
         KEY `status` (`status`),
         KEY `LCID` (`LCID`),
         KEY `EVID` (`EVID`),
         KEY `GGID` (`GGID`),
         KEY `type` (`type`),
         KEY `league` (`league`)
         ) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;";

		if (!$wpdb->query($q)) {
			$errors++;
			if ($msg = $wpdb->last_error) {
				$this->errorMsgs[] = $msg;
			}
		}

		return $errors;
	}

	protected function createPlayersTable($tablename)
	{
		global $wpdb;
		$errors = 0;

		$q = "CREATE TABLE `{$tablename}` (
			`ID` int(11) unsigned NOT NULL AUTO_INCREMENT,
			`modified_utc` datetime DEFAULT NULL COMMENT 'last update gmt',
			`modified_local` datetime DEFAULT NULL COMMENT 'last update local time',
			`LCID` int(11) unsigned NOT NULL COMMENT 'location ID',
			`PLID` int(11) unsigned NOT NULL COMMENT 'player ID',
			`address` tinyint(2) NOT NULL COMMENT '-1 none, 0 male, 1 female, 2 divers',
			`ensign` char(2) DEFAULT NULL COMMENT 'nationality',
			`lang` char(2) DEFAULT NULL COMMENT 'language',
			`anonymous` tinyint(2) NOT NULL COMMENT '0 false, 1 true',
			`MEID` tinyint(3) NOT NULL COMMENT 'member type, 0 guest, 2 member, 3 honor, 4 vip',
			`dname` varchar(128) DEFAULT NULL COMMENT 'composed display name',
			`fname` varchar(64) DEFAULT NULL COMMENT 'first name',
			`lname` varchar(64) DEFAULT NULL COMMENT 'last name',
			`nname` varchar(64) DEFAULT NULL COMMENT 'nickname',
			`mdno` varchar(32) DEFAULT NULL COMMENT 'media number',
			`email` varchar(128) DEFAULT NULL COMMENT 'email',
			`pw` varchar(255) DEFAULT NULL COMMENT 'password',
			`pw_code` varchar(255) DEFAULT NULL,
			`pw_time` timestamp NULL DEFAULT NULL,
			`login_count` int(11) unsigned DEFAULT NULL,
			`login_last` timestamp NULL DEFAULT NULL,
			`sctables` int(11) unsigned NOT NULL DEFAULT '0',
			`sctime` int(11) unsigned NOT NULL DEFAULT '0',
			`tctables` int(11) unsigned NOT NULL DEFAULT '0',
			`tctime` int(11) unsigned NOT NULL DEFAULT '0',
			`fpp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'frequent player points',
			`bal0value` double NOT NULL DEFAULT '0' COMMENT 'balance currency 0',
			`bal1value` double NOT NULL DEFAULT '0' COMMENT 'balance currency 1',
			`bal2value` double NOT NULL DEFAULT '0' COMMENT 'balance currency 2',
			`bal3value` double NOT NULL DEFAULT '0' COMMENT 'balance currency 3',
			`bal4value` double NOT NULL DEFAULT '0' COMMENT 'balance currency 4',
			`stat0value` double NOT NULL DEFAULT '0',
			`stat0count` int(11) unsigned NOT NULL DEFAULT '0',
			`stat0ptime` int(11) unsigned NOT NULL DEFAULT '0',
			`stat1value` double NOT NULL DEFAULT '0',
			`stat1count` int(11) unsigned NOT NULL DEFAULT '0',
			`stat1ptime` int(11) unsigned NOT NULL DEFAULT '0',
			`stat2value` double NOT NULL DEFAULT '0',
			`stat2count` int(11) unsigned NOT NULL DEFAULT '0',
			`stat2ptime` int(11) unsigned NOT NULL DEFAULT '0',
			`stat3value` double NOT NULL DEFAULT '0',
			`stat3count` int(11) unsigned NOT NULL DEFAULT '0',
			`stat3ptime` int(11) unsigned NOT NULL DEFAULT '0',
			`stat4value` double NOT NULL DEFAULT '0',
			`stat4count` int(11) unsigned NOT NULL DEFAULT '0',
			`stat4ptime` int(11) unsigned NOT NULL DEFAULT '0',
			`earn0value` double NOT NULL DEFAULT '0',
			`earn0count` int(11) unsigned NOT NULL DEFAULT '0',
			`earn0ptime` int(11) unsigned NOT NULL DEFAULT '0',
			`earn1value` double NOT NULL DEFAULT '0',
			`earn1count` int(11) unsigned NOT NULL DEFAULT '0',
			`earn1ptime` int(11) unsigned NOT NULL DEFAULT '0',
			`earn2value` double NOT NULL DEFAULT '0',
			`earn2count` int(11) unsigned NOT NULL DEFAULT '0',
			`earn2ptime` int(11) unsigned NOT NULL DEFAULT '0',
			`earn3value` double NOT NULL DEFAULT '0',
			`earn3count` int(11) unsigned NOT NULL DEFAULT '0',
			`earn3ptime` int(11) unsigned NOT NULL DEFAULT '0',
			`earn4value` double NOT NULL DEFAULT '0',
			`earn4count` int(11) unsigned NOT NULL DEFAULT '0',
			`earn4ptime` int(11) unsigned NOT NULL DEFAULT '0',
			PRIMARY KEY (`ID`),
			UNIQUE KEY `Unique Host ID` (`LCID`,`PLID`),
			KEY `LCID` (`LCID`),
			KEY `Local Stat0 Count` (`LCID`,`stat0count`),
			KEY `Local Stat1 Count` (`LCID`,`stat1count`),
			KEY `Local Stat2 Count` (`LCID`,`stat2count`),
			KEY `Local Stat3 Count` (`LCID`,`stat3count`),
			KEY `Local Stat4 Count` (`LCID`,`stat4count`),
			KEY `Local Earn0 Count` (`LCID`,`earn0count`),
			KEY `Local Earn1 Count` (`LCID`,`earn1count`),
			KEY `Local Earn2 Count` (`LCID`,`earn2count`),
			KEY `Local Earn3 Count` (`LCID`,`earn3count`),
			KEY `Local Earn4 Count` (`LCID`,`earn4count`)
			) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;";

		if (!$wpdb->query($q)) {
			$errors++;
			if ($msg = $wpdb->last_error) {
				$this->errorMsgs[] = $msg;
			}
		}

		return $errors;
	}

	protected function dropTable($tablename)
	{
		global $wpdb;
		$errors = 0;

		$q = $wpdb->prepare("DROP TABLE {$tablename};");
		if (!$wpdb->query($q)) {
			$errors++;
			if ($msg = $wpdb->last_error) {
				$this->errorMsgs[] = $msg;
			}
		}
		return $errors;
	}

	public function recreateTable($name)
	{
		global $wpdb;
		$errors = 0;

		$tablename = $wpdb->prefix . 'cw_' . $name;
		if ($this->hasTableWithName($tablename)) {
			$errors += $this->dropTable($tablename);
		}
		if ($errors == 0) {
			switch ($name) {
				case 'players':
					$errors += $this->createPlayersTable($tablename);
					break;
				case 'tournaments':
					$errors += $this->createTournamentsTable($tablename);
					break;
				case 'cashgames':
					$errors += $this->createCashGamesTable($tablename);
					break;
			}
		}

		return $errors;
	}
}
