(function (blocks, element, editor, components) {
	const el = element.createElement;
	const { Fragment } = element;
	const { TextControl, ToggleControl, ColorPalette, Panel, PanelBody, PanelRow } = components;
	const { RichText, InspectorControls } = editor;
	blocks.registerBlockType('cw/event-list', {
		apiVersion: 2,
		description: "dgdfgfddf",
		attributes: {
			message_field: {
				type: "string",
				// source: "text",
				// selector: "div",
				default: "Message" // empty default
			},
			bg_color: {
				type: "string",
				default: "#000000"
			},
			text_color: {
				type: "string",
				default: "#ffffff"
			},
			list_id: {
				type: 'string'
				// default: '12345' // you can set a default value
			},
			doubleoptin: {
				type: 'boolean' // for ToggleControl we need boolean type
			}
		},
		edit: function (props) {
			const onChangeMessageField = (val) => {
				props.setAttributes({
					message_field: val
				});
			};

			var blockProps = editor.useBlockProps();
			return el(
				Fragment, null,
				el(InspectorControls, null,
					el(PanelBody, { title: 'List Settings', initialOpen: true },
						/* Text Field */
						el(PanelRow, {},
							el(TextControl,
								{
									label: 'List ID',
									onChange: (value) => {
										props.setAttributes({ list_id: value });
									},
									value: props.attributes.list_id
								}
							)
						),
						/* Toggle Field */
						el(PanelRow, {},
							el(ToggleControl,
								{
									label: 'Double Opt In',
									onChange: (value) => {
										props.setAttributes({ doubleoptin: value });
									},
									checked: props.attributes.doubleoptin,
								}
							)
						),
						/* ColorPalette */
						el('p', null, "Background Color"),
						el(PanelRow, {},
							el(ColorPalette,
								{
									enableAlpha: true,
									value: props.attributes.bg_color,
									colors: [{ name: 'red', color: '#f00' }, { name: 'white', color: '#fff' }, { name: 'blue', color: '#00f' }],
									onChange: (value) => {
										props.setAttributes({ bg_color: value });
									}
								}
							)
						),
						/* ColorPalette */
						el('p', null, "Text Color"),
						el(PanelRow, {},
							el(ColorPalette,
								{
									value: props.attributes.text_color,
									colors: [{ name: 'red', color: '#f00' }, { name: 'white', color: '#fff' }, { name: 'blue', color: '#00f' }],
									onChange: (value) => {
										props.setAttributes({ text_color: value });
									}
								}
							)
						)

					),
				),
				el("div",
					blockProps,
					el(components.TextControl, {
						value: props.attributes.message_field,
						onChange: onChangeMessageField,
						style: {
							backgroundColor: props.attributes.bg_color,
							color: props.attributes.text_color
						}
					})
				)
			);
		},
		save: function (props) {
			var blockProps = editor.useBlockProps.save();
			blockProps.style = { background: props.attributes.bg_color, color: props.attributes.text_color };
			return el(
				'p',
				blockProps,
				props.attributes.message_field
			);
		},
	});
})(window.wp.blocks, window.wp.element, window.wp.blockEditor, window.wp.components);
