<?php
defined('ABSPATH') or die('No direct access');
class CWTournamentList extends CWBaseList
{
	public function __construct($figure, $id = 0)
	{
		parent::__construct('tournament', $figure, $id);
	}

	/* ---------------------------------------------- */
	/* Override
	/* ---------------------------------------------- */
	public function loadData($attr)
	{
		if (0 == $this->generalOptionForKey($this->game . 's_manager', 0)) {
			return null;
		}
		if (!$this->list) {
			switch ($this->valueForKey($attr, 'type', CWEnumGameType::Dated)) {
				case CWEnumGameType::SitGo:
					$order = " ORDER BY `title`";
					break;
				case CWEnumGameType::Ring:
					$order = " ORDER BY `title`";
					break;
				default:
				if ($this->figure == 'results') {
					$order = " ORDER BY `type` DESC, `start_local` DESC, `title`";
				} else {
					$order = " ORDER BY `type` DESC, `start_local`, `title`";
				}
			}
			$args = [
				'class' => 'CWTournament',
				'select' => '`ID`, `params`,`levels`',
				'order' => $order
			];
			$this->list = $this->getRowsWithAttr($attr, $args);
		}
		return $this->list;
	}

	/* ---------------------------------------------- */
	/* Render Table List
	/* ---------------------------------------------- */
}
