<?php
defined('ABSPATH') or die('No direct access');
class CWTournamentsTable extends CWGamesTable
{
   public function __construct()
   {
      $idfield = 'TTID';
      $fieldnames = [
         'LCID', 'modified_utc', 'modified_local',
         $idfield, 'EVID', 'GGID', 'status', 'pub', 'type', 'league', 'start_local', 'title',
         'params', 'entries', 'tables', 'waits', 'levels', 'payouts'
      ];
      $fieldtypes = [
         '%d', '%s', '%s',
         '%d', '%d', '%d', '%d', '%d', '%d', '%s', '%s', '%s',
         '%s', '%s', '%s', '%s', '%s', '%s'
      ];
      parent::__construct('tournaments', $idfield, $fieldnames, $fieldtypes);
   }

   public function prepare_items()
   {
      parent::prepare_items();
      $this->search_fields = ['title', 'league', 'start_local'];
      $this->getRows('`ID`,`LCID`,`params`', 'CWTournament');

      $args = ['total_items' => $this->total, 'per_page' => $this->limit];
      $this->set_pagination_args($args);
   }

   public function get_columns()
   {
      $columns = [
         'cb' => '<input type="checkbox" />',
         'cw-title' => esc_html__('Title', CWSLUG),
         'cw-status' => esc_html__('Status', CWSLUG),
         'cw-start_local' => esc_html__('Start', CWSLUG),
         'cw-pub' => esc_html__('Published'),
         'cw-evid' => esc_html__('EVID', CWSLUG),
         'cw-lcid' => esc_html__('LCID', CWSLUG),
         'cw-ttid' => esc_html__('TTID', CWSLUG),
         'cw-id' => esc_html__('ID', CWSLUG)
      ];
      return $columns;
   }

   public function get_sortable_columns()
   {
      return [
         'cw-title' => ['title', 'asc'],
         'cw-status' => ['status', 'desc'],
         'cw-lcid' => ['LCID', 'asc'],
         'cw-ttid' => ['TTID', 'asc'],
         'cw-evid' => ['EVID', 'asc'],
         'cw-start_local' => ['start_local', 'asc'],
         'cw-id' => ['ID', 'desc']
      ];
   }
}
