<?php
defined('ABSPATH') or die('No direct access');
trait CWFoundationTrait
{
	/* ---------------------------------------------- */
	/* Get/Postlerts */
	/* ---------------------------------------------- */
	public function getPost($name, $default = null)
	{
		if (isset($_GET[$name]))
			return $_GET[$name];
		else if (isset($_POST[$name]))
			return $_POST[$name];
		return $default;
	}

	public function getPosts($names, $trim = false)
	{
		$ar = [];
		foreach ($names as &$name) {
			if ($trim) {
				$v = $this->getPost($name);
				if (gettype($v) == "string") {
					$v = trim($v);
				}
				$ar[$name] = $v;
			} else {
				$ar[$name] = $this->getPost($name);
			}
		}
		return $ar;
	}

	/* ---------------------------------------------- */
	/* Functions
	/* ---------------------------------------------- */
	public function valueForKey(&$ar, $key, $default = null)
	{
		return ('array' == gettype($ar) && isset($ar[$key])) ? $ar[$key] : $default;
	}

	public function generalOptionForKey($key, $default = null)
	{
		$options = get_option('cw_options_general');
		return $this->valueForKey($options, $key, $default);
	}

	public function allCurrencies($count = 5)
	{
		$options = get_option('cw_options_general');
		$currencies = [];
		for ($currency = 0; $currency < $count; $currency++) {
			$currencies[] = $this->valueForKey($options, "currency_{$currency}", "");
		}
		return $currencies;
	}

	/* ---------------------------------------------- */
	/* Formatter
	/* ---------------------------------------------- */
	public function formatValueWithCurrency($value, $currency = 0, $decimals = 0, $short = true)
	{
		$cur = $this->generalOptionForKey("currency_{$currency}", "");
		$pos = $this->generalOptionForKey("currency_pos_{$currency}", 0);
		$v = "";
		if (1 == $pos) {
			$v .= $cur;
		}
		if (0 < $decimals && $short) {
			if (doubleval($value) == intval($value)) {
				$decimals = 0;
			}
		}
		$v .= number_format_i18n($value, $decimals);
		if (2 == $pos) {
			$v .= $cur;
		}
		return $v;
	}

	public function formatDuration($secs)
	{
		$v = intval($secs);
		$h = intval($v / 3600);
		$v -= $h * 3600;
		$m = intval($v / 60);
		$v -= $m * 60;
		$out = sprintf('%02d:%02d:%02d', $h, $m, $v);

		return $out;
	}
}
