<?php
defined('ABSPATH') or die('No direct access');
function cwAutoloader($cName): bool
{
	$load = "classes" . DIRECTORY_SEPARATOR;
	$namespace = explode('\\', $cName);
	if (1 < count($namespace)) {
		$cName = end($namespace);
		$folder = $namespace[0];
		$load .= $folder . DIRECTORY_SEPARATOR . "$cName.class.php";
	} elseif (false !== strpos($cName, 'Enum')) {
		$load .= "enums" . DIRECTORY_SEPARATOR;
	} elseif (false !== strpos($cName, 'Table')) {
		$load .= "tables" . DIRECTORY_SEPARATOR;
	} elseif (false !== strpos($cName, 'List')) {
		$load .= "lists" . DIRECTORY_SEPARATOR;
	} elseif (false !== strpos($cName, 'Trait')) {
		$load .= "traits" . DIRECTORY_SEPARATOR;
	}
	$load .= "$cName.class.php";
	$path = CWPATH . $load;
	if (file_exists($path)) {
		return include_once $path;
	}
	$path = $load;
	if (file_exists($path)) {
		return include_once $path;
	}
	return false;
}
spl_autoload_register('cwAutoloader');
