<?php
defined('ABSPATH') or die('No direct access');
$options = get_option('cw_options_cashgame_details');
$option_wrapper = $this->valueForKey($options, 'wrapper');
if (($option_card = $this->valueForKey($attr, 'card')) === null) {
	$option_card = $this->valueForKey($options, 'card', 0);
}
$option_card_footer = $this->valueForKey($options, 'card_footer');
if (($option_entries = $this->valueForKey($attr, 'entries')) === null) {
	$option_entries = $this->valueForKey($options, 'entries', 0);
}
if (($option_tables = $this->valueForKey($attr, 'tables')) === null) {
	$option_tables = $this->valueForKey($options, 'tables', 0);
}
if (($option_waits = $this->valueForKey($attr, 'waits')) === null) {
	$option_waits = $this->valueForKey($options, 'waits', 0);
}
if ($option_wrapper) {
	echo "<div class=\"cw-wrapper\" style=\"max-width:none;\">" . PHP_EOL;
}
$status = $this->status(true);
?>
<div class="cw-container">
	<?php if ($option_card) : ?>
		<div class="cw-card">
			<div class="cw-card-header">
				<div class="cw-col cw-text-center">
					<h1 class="cw-game-title"><?= $this->formattedParamValue('title') ?: ""; ?></h1>
				</div>
			</div>

			<div class="cw-card-body">
			<?php endif; ?>
			<div class="cw-clock cw-font-wrapper">
				<!-- Board -->
				<?php
				$text = $this->formattedParamValue('shortdesc');
				if (!empty($text)) :
				?>
					<div class="cw-row">
						<div class="cw-col cw-text-center">
							<p class="cw-game-shortdesc"><?= $text; ?></p>
						</div>
					</div>
				<?php
				endif;
				$text = $this->formattedParamValue('additional_buyins');
				if (!empty($text)) :
				?>
					<div class="cw-row">
						<div class="cw-col cw-text-center">
							<p class="cw-game-buyins"><?= $this->formattedParamValue('additional_buyins') ?: ""; ?></p>
						</div>
					</div>
				<?php endif; ?>
				<!-- Row 0 -->
				<div class="cw-row">
					<div class="cw-col-12 cw-mt-2">
						<div class="cw-clock-element">
							<div><label>Status&nbsp;</label><?= $this->formattedParamValue('reg') ?: ""; ?></div>
						</div>
					</div>
				</div>

				<!-- Row 1 -->
				<div class="cw-row cw-clock-row">
					<div class="cw-col-12 cw-col-md-3 cw-mt-2">
						<div class="cw-clock-element cw-clock-field" id="cw_clock_playersentries_field">
							<div class="cw-clock-grid-cell">
								<div class="cw-clock-label">Players</div>
								<div class="cw-clock-value-side" id="cw_clock_playersentries"><?= $this->formattedParamValue('countpls'); ?></div>
							</div>
						</div>
					</div>
					<div class="cw-col-12 cw-col-md-6 cw-mt-2">
						<div class="cw-clock-element cw-clock-field">
							<div class="cw-clock-grid-cell">
								<div class="cw-clock-label">Buy-In</div>
								<div class="cw-clock-value-side"><?= $this->formattedParamValue('minmax'); ?></div>
							</div>
						</div>
					</div>
					<div class="cw-col-12 cw-col-md-3 cw-mt-2">
						<div class="cw-clock-element cw-clock-field">
							<div class="cw-clock-grid-cell">
								<div class="cw-clock-label">Waiting</div>
								<div class="cw-clock-value-side"><?= $this->formattedParamValue('countwas'); ?></div>
							</div>
						</div>
					</div>
				</div>
				<!-- End Board -->

				<?php
				if ($status >= 2 && $status <= 8) {
					include(CWPATH . "templates/cashgame-entries.php");
					if ($option_entries) {
						include(CWPATH . "templates/cashgame-entries.php");
					}
					if ($option_tables && $status <= 8) {
						include(CWPATH . "templates/cashgame-tables.php");
					}
					if ($option_waits) {
						include(CWPATH . "templates/game-waiting-list.php");
					}
				}
				?>
			</div>
			<?php if ($option_card) : ?>
			</div>
			<div class="cw-card-footer">
				<div class="cw-row">
					<div class="cw-col cw-powered">
						Tournament Director's Discretion
					</div>
					<div class="cw-col cw-text-end cw-powered">
						<a href="https://casinoware.com" target="_blank" style="color:#212529;">powered by CasinoWare.com</a>
					</div>
				</div>
			</div>
		</div>
	<?php else : ?>
		<div class="cw-row">
			<div class="cw-col cw-powered cw-text-center">
				<a href="https://casinoware.com" target="_blank">powered by CasinoWare.com</a>
			</div>
		</div>
	<?php endif; ?>
</div>
<?php
if ($option_wrapper) {
	echo "</div>" . PHP_EOL;
}
?>