<?php
defined('ABSPATH') or die('No direct access');
$options = get_option("cw_options_leaderboard");
$option_wrapper = $this->valueForKey($options, 'wrapper');
if (($option_hide = $this->valueForKey($attr, 'hide')) === null) {
	$option_hide = $this->valueForKey($options, 'hide', 0);
}
$list = $this->loadData($attr); // $attr are attributes from shortcode or widget
if ($option_hide && empty($list)) return;
if (($option_card = $this->valueForKey($attr, 'card')) === null) {
	$option_card = $this->valueForKey($options, 'card', 0);
}
// manipulate the options with the shortcode attr
if (isset($options['ptime']) && ($opt = $this->valueForKey($attr, 'col_ptime')) !== null) {
	$options['ptime']['enabled'] = intval($opt);
}
if (isset($options['ensign']) && ($opt = $this->valueForKey($attr, 'col_ensign')) !== null) {
	$options['ensign']['enabled'] = intval($opt);
}
if (isset($options['curcount']) && ($opt = $this->valueForKey($attr, 'col_cur_count')) !== null) {
	$options['curcount']['enabled'] = intval($opt);
}
// Title and footer
if (($title = $this->valueForKey($attr, 'title')) === null) {
	$title = $this->valueForKey($options, 'card_title', "");
}
if (($footer = $this->valueForKey($attr, 'footer')) === null) {
	$footer = $this->valueForKey($options, 'card_footer', "");
}
// Start table rendering
if ($option_wrapper) {
	echo "<div class=\"cw-wrapper\" style=\"max-width:none;\">" . PHP_EOL;
}
?>
<div class="cw-container">
	<?php if ($option_card) : ?>
		<div class="cw-card">
			<?php if (!empty($title)) : ?>
				<div class="cw-card-header">
					<div class="cw-col cw-text-center">
						<h1 class="cw-game-title"><?= $title; ?></h1>
					</div>
				</div>
			<?php endif; ?>
			<div class="cw-card-body">
				<?php include CWPATH . "templates/leaderboard-body.php"; ?>
			</div>
			<div class="cw-card-footer">
				<div class="cw-row">
					<div class="cw-col cw-powered"><?= $footer; ?></div>
					<div class="cw-col cw-text-end cw-powered"><a href="https://casinoware.com" target="_blank" style="color:#212529;">powered by CasinoWare.com</a></div>
				</div>
			</div>
		</div>
	<?php else : ?>
		<?php if (!empty($title)) : ?>
			<div class="cw-text-center">
				<h1 class="cw-game-title"><?= $title; ?></h1>
			</div>
		<?php endif; ?>
		<?php include CWPATH . "templates/leaderboard-body.php"; ?>
		<div class="cw-text-center cw-powered"><?= $footer; ?></div>
		<div class="cw-text-center cw-powered cw-mt-2">
			<a href="https://casinoware.com" target="_blank">powered by CasinoWare.com</a>
		</div>
	<?php endif; ?>
</div>
<?php
if ($option_wrapper) echo "</div>" . PHP_EOL;
?>