<?php
defined('ABSPATH') or die('No direct access');
?>
<div class="cw-clock cw-font-wrapper">
   <!-- Board -->
   <?php
   $text = $this->formattedParamValue('shortdesc');
   if (!empty($text)) {
      echo '<div class="cw-row">';
      echo '<div class="cw-col cw-text-center">';
      echo '<span class="cw-game-shortdesc">' . $text . '</span>';
      echo '</div>';
      echo '</div>' . PHP_EOL;
   }
   $text = $this->formattedParamValue('additional_buyins');
   if (!empty($text) && $this->valueForKey($options, 'additional_buyins', 0)) {
      echo '<div class="cw-row">';
      echo '<div class="cw-col cw-text-center">';
      echo '<span class="cw-game-buyins">' . $text . '</span>';
      echo '</div>';
      echo '</div>' . PHP_EOL;
   }
   ?>
   <!-- Row 0 -->
   <div class="cw-row">
      <div class="cw-col-12 cw-col-md-4 cw-mt-2">
         <div class="cw-clock-element cw-clock-center">
            <div>
               <label>&nbsp;Status&nbsp;</label>
               <strong><?= $this->formattedParamValue('status') ?: ""; ?></strong>
            </div>
         </div>
      </div>
      <div class="cw-col-12 cw-col-md-8 cw-mt-2">
         <div class="cw-clock-element cw-clock-center">
            <div>
               <label>&nbsp;Registration&nbsp;</label>
               <?= $this->formattedParamValue('reg.level'); ?>
            </div>
         </div>
      </div>
   </div>
   <?php
   $temp = CWEnumGameStatus::Finished >= $status && CWEnumGameStatus::Initiate <= $status ? $status : CWEnumGameStatus::Initiate;
   $file = CWPATH . "templates/tournament-board-{$temp}.php";
   if (file_exists($file)) {
      include($file);
   }
   ?>
   <!-- End Board -->
   <?php
   if (CWEnumGameStatus::Finished <= $status) {
      if ($option_entries) {
         include(CWPATH . "templates/tournament-results.php");
      }
   } else if (CWEnumGameStatus::Register <= $status) {
      if ($option_payouts && CWEnumGameStatus::Running == $status) {
         include(CWPATH . "templates/tournament-payouts.php");
      }
      if ($option_entries) {
         include(CWPATH . "templates/tournament-entries.php");
      }
      if ($option_tables && CWEnumGameStatus::Running >= $status) {
         include(CWPATH . "templates/tournament-tables.php");
      }
      if ($option_waits) {
         include(CWPATH . "templates/game-waiting-list.php");
      }
   }
   if ($option_levels && CWEnumGameStatus::Finished > $status) {
      include(CWPATH . "templates/tournament-levels.php");
   }
   if ($option_htmldesc) {
      $text = $this->paramValue('htmldesc');
      if (!empty($text)) {
         echo $text . PHP_EOL;
      }
   }
   ?>
</div>