<?php
defined('ABSPATH') or die('No direct access');
if ($entries = $this->entries) :
   $allowbts = $this->paramValue('allowbts', 0);
   $btmode = $this->paramValue('btmode', CWEnumGameBountyMode::Free);
   $hasBounties = $allowbts && CWEnumGameBountyMode::Free < $btmode;
   $hasRewards = $allowbts && (CWEnumGameBountyMode::Standard == $btmode || CWEnumGameBountyMode::Progressive == $btmode);
   usort($entries, function ($entry1, $entry2) {
      $play1 = $this->valueForKey($entry1, 'playing', 0);
      $play2 = $this->valueForKey($entry2, 'playing', 0);
      $c = ($play2 <=> $play1);
      if (0 !== $c) return $c;
      if ($play1) {
         $stack1 = intval($this->valueForKey($entry1, 'stack', 0));
         $stack2 = intval($this->valueForKey($entry2, 'stack', 0));
         $c = $stack2 <=> $stack1;
      } else {
         $rank1 = intval($this->valueForKey($entry1, 'place', 0));
         $rank2 = intval($this->valueForKey($entry2, 'place', 0));
         if (!empty($rank1) && empty($rank2)) return -1;
         if (empty($rank1) && !empty($rank2)) return 1;
         $c = $rank1 <=> $rank2;
      }
      if (0 !== $c) return $c;
      $dname1 = strtolower($this->valueForKey($entry1, 'dname', ''));
      $dname2 = strtolower($this->valueForKey($entry2, 'dname' . ''));
      return $dname1 <=> $dname2;
   });
?>
   <!-- Tournament Entries -->
   <div class="cw-row cw-pt-5">
      <div class="cw-col">
         <h4 class="cw-text-center"><?php echo __('Entries', CWSLUG); ?></h4>
         <?php
         $stackupdate_local = $this->formattedParamValue('stackupdate_local');
         if (!empty($stackupdate_local)) {
            echo "<p class=\"cw-text-center cw-updated cw-mb-0\">Last Chip Update: <strong>" . $stackupdate_local . "</strong></p>" . PHP_EOL;
         }
         ?>
         <table class="cw-table-list cw-mx-auto cw-w-max-600px">
            <thead>
               <tr class="cw-tr">
                  <th class="cw-th cw-hide-sm" style="width:30px;"></th>
                  <th class="cw-th">Name</th>
                  <th class="cw-th" style="width:20%;">Table / Seat</th>
                  <?php
                  if ($hasRewards) {
                     echo '<th class="cw-th" style="width:15%;">Reward</th>';
                     echo '<th class="cw-th" style="width:15%;">Chips</th>';
                  } else if ($hasBounties) {
                     echo '<th class="cw-th" colspan="2" style="width:30%;">Chips</th>';
                  } else {
                     echo '<th class="cw-th" style="width:15%;">Chips</th>';
                  }
                  ?>
               </tr>
            </thead>
            <tbody>
               <?php
               $section = 0;
               foreach ($entries as $entry) {
                  $dname = $this->formattedEntryValue('dname', $entry);
                  $tableseat = $this->formattedEntryValue('tableseat', $entry);
                  $ensign = $this->formattedSeatValue('ensign', $entry);
                  if (0 == $section) {
                     if (0 == $this->valueForKey($entry, 'playing', 0)) {
                        $section = 1;
                        echo '<tr class="cw-tr">';
                        echo '<th class="cw-th cw-hide-sm"></th>';
                        echo '<th class="cw-th">Name</th>';
                        echo '<th class="cw-th">Rank</th>';
                        if ($hasBounties) {
                           echo '<th class="cw-th">Bounties</th>';
                        }
                        echo '<th class="cw-th">Winnings</th></tr>' . PHP_EOL;
                     }
                  }

                  echo "<tr class=\"cw-tr\">";
                  echo "<td class=\"cw-td cw-text-center cw-hide-sm\">{$ensign}</td>";
                  echo "<td class=\"cw-td cw-text-start\">{$dname}</td>";
                  echo "<td class=\"cw-td cw-text-center\">{$tableseat}</td>";
                  if ($hasRewards && 0 == $section) {
                     $reward = $this->formattedEntryValue('bounty.rewards', $entry);
                     echo "<td class=\"cw-td cw-text-end\">{$reward}</td>";
                  } else if ($hasBounties && 0 != $section) {
                     $reward = $this->formattedEntryValue('bounty.winnings', $entry);
                     echo "<td class=\"cw-td cw-text-end\">{$reward}</td>";
                  }
                  if (0 == $section) {
                     $stack = $this->formattedEntryValue('stack', $entry);
                     echo '<td class="cw-td cw-text-end" colspan="2">' . $stack . '</td></tr>' . PHP_EOL;
                  } else {
                     $stack = $this->formattedEntryValue('winnings', $entry);
                     echo "<td class=\"cw-td cw-text-end\">{$stack}</td></tr>" . PHP_EOL;
                  }
               }
               ?>
            </tbody>
         </table>
      </div>
   </div>
   <!-- Tournament Entries End -->
<?php endif; ?>