<?php
defined('ABSPATH') or die('No direct access');
if ($results = $this->entries) :
	$allowbts = $this->paramValue('allowbts', 0);
	$btmode = $this->paramValue('btmode', 0);
	$hasRewards = $allowbts && $btmode > 0;
	usort($results, function ($entry1, $entry2) {
		$play1 = $this->valueForKey($entry1, 'playing', 0);
		$play2 = $this->valueForKey($entry2, 'playing', 0);
		$c = ($play2 <=> $play1);
		if (0 !== $c) return $c;
		if ($play1) {
			$stack1 = intval($this->valueForKey($entry1, 'stack', 0));
			$stack2 = intval($this->valueForKey($entry2, 'stack', 0));
			$c = $stack2 <=> $stack1;
		} else {
			$rank1 = intval($this->valueForKey($entry1, 'place', 0));
			$rank2 = intval($this->valueForKey($entry2, 'place', 0));
			if (!empty($rank1) && empty($rank2)) return -1;
			if (empty($rank1) && !empty($rank2)) return 1;
			$c = $rank1 <=> $rank2;
		}
		if (0 !== $c) return $c;
		$dname1 = strtolower($this->valueForKey($entry1, 'dname', ''));
		$dname2 = strtolower($this->valueForKey($entry2, 'dname' . ''));
		return $dname1 <=> $dname2;
	});
?>
	<!-- Tournament Results -->
	<div class="cw-row cw-pt-5">
		<div class="cw-col">
			<h4 class="cw-text-center"><?php echo __('Result', CWSLUG); ?></h4>
			<table class="cw-table-list cw-mx-auto cw-w-max-600px">
				<thead>
					<tr class="cw-tr">
						<th class="cw-th" style="width:40px;">Rank</th>
						<th class="cw-th cw-hide-sm" style="width:30px;"></th>
						<th class="cw-th">Name</th>
                  <?php
                  if ($hasRewards) {
                     echo '<th class="cw-th" style="width:20%;">Bounties</th>';
                  }
                  ?>
						<th class="cw-th" style="width:20%;">Winnings</th>
					</tr>
				</thead>
				<tbody>
					<?php
					$section = 0;
					foreach ($results as $entry) {
						$dname = $this->formattedEntryValue('dname', $entry);
						$rank = $this->formattedEntryValue('place', $entry);
						$ensign = $this->formattedSeatValue('ensign', $entry);
						if ($hasRewards) {
							$reward = $this->formattedEntryValue('bounty.winnings', $entry);
						} else {
							$reward = "";
						}
						if (0 == $this->valueForKey($entry, 'playing', 0)) {
							$winnings = $this->formattedEntryValue('winnings', $entry);
						} else {
							$winnings = __("Qualified", CWSLUG);
						}
						echo "<tr class=\"cw-tr\">";
						echo "<td class=\"cw-td cw-text-center\"><strong>{$rank}</strong></td>";
						echo "<td class=\"cw-td cw-text-center cw-hide-sm\">{$ensign}</td>";
						echo "<td class=\"cw-td cw-text-start\">{$dname}</td>";
						if ($hasRewards) {
							echo "<td class=\"cw-td cw-text-end\">{$reward}</td>";
						}
						echo "<td class=\"cw-td cw-text-end\">{$winnings}</td></tr>" . PHP_EOL;
					}
					?>
				</tbody>
			</table>
		</div>
	</div>
	<!-- Tournament Results End -->
<?php endif; ?>