<?php
defined('ABSPATH') or die('No direct access');
if ($tables = $this->tables) :
   usort($tables, function ($table1, $table2) {
      $v1 = $this->valueForKey($table1, 'occupiedseats', 0);
      $v2 = $this->valueForKey($table2, 'occupiedseats', 0);
      if (!empty($v1) && empty($v2)) return -1;
      if (empty($v1) && !empty($v2)) return 1;
      $name1 = strtolower($this->valueForKey($table1, 'name', ''));
      $name2 = strtolower($this->valueForKey($table2, 'name' . ''));
      return strnatcmp($name1, $name2);
   });
   $stackupdate_local = $this->formattedParamValue('stackupdate_local');
?>
   <!-- Tournament Tables -->
   <div class="cw-row cw-mt-5">
      <div class="cw-col">
         <h4 class="cw-text-center"><?php echo __('Tables', CWSLUG); ?></h4>
         <?php if (!empty($stackupdate_local)) : ?>
            <p class="cw-text-center cw-updated cw-mb-0">Last Chip Update: <strong><?= $stackupdate_local ?></strong></p>
         <?php endif; ?>
         <table class="cw-table-list cw-mx-auto cw-w-max-600px">
            <thead>
               <tr class="cw-tr">
                  <th class="cw-th" style="width:40px;">Seat</th>
                  <th class="cw-th cw-hide-sm" style="width:30px;"></th>
                  <th class="cw-th">Name</th>
                  <th class="cw-th" style="width:20%;">Chips</th>
               </tr>
            </thead>
            <tbody>
               <?php
               $default = __('Table', CWSLUG);
               foreach ($tables as $table) {
                  $name = $this->valueForKey($table, 'name', $default);
                  echo "<tr class=\"cw-tr\"><td class=\"cw-td cw-text-center cw-bg-table cw-color-dark\" colspan=\"4\"><strong>{$name}</strong></td></tr>" . PHP_EOL;
                  foreach ($table['seats'] as $seat) {
                     $dname = $this->formattedSeatValue('dname', $seat);
                     $ensign = $this->formattedSeatValue('ensign', $seat);
                     $seatno = $this->formattedSeatValue('SENO', $seat);
                     $stack = $this->formattedSeatValue('stack', $seat);
                     $ensign = $this->formattedSeatValue('ensign', $seat);
                     echo "<tr class=\"cw-tr\"><td class=\"cw-td cw-text-center\">{$seatno}</td><td class=\"cw-td cw-text-center cw-hide-sm\">{$ensign}</td><td class=\"cw-td cw-text-start\">{$dname}</td><td class=\"cw-td cw-text-end\">{$stack}</td></tr>" . PHP_EOL;
                  }
               }
               ?>
            </tbody>
         </table>
      </div>
   </div>
   <!-- Tournament Tables End -->
<?php endif; ?>